# coding: utf-8

"""
Earnix DataService API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 0.0.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic.v1 import Field, StrictInt, StrictStr, conlist, constr, validator

from earnix_elevate.clients.data.models.update_data_set_node_request import (
    UpdateDataSetNodeRequest,
)


class UpdateDataSetRecipeNodeRequest(UpdateDataSetNodeRequest):
    """
    UpdateDataSetRecipeNodeRequest
    """

    name: Optional[constr(strict=True, max_length=100, min_length=3)] = None
    description: Optional[constr(strict=True, max_length=500)] = None
    tags: Optional[conlist(StrictStr, unique_items=True)] = None
    id: Optional[StrictInt] = None
    lock_version: Optional[StrictInt] = Field(default=None, alias="lockVersion")
    code: Optional[constr(strict=True, max_length=10000, min_length=3)] = Field(
        default=None, description="code of the recipe"
    )
    language: Optional[StrictStr] = Field(
        default=None, description="language of the recipe"
    )
    __properties = [
        "nodeType",
        "dataSetId",
        "name",
        "description",
        "tags",
        "id",
        "lockVersion",
        "code",
        "language",
    ]

    @validator("language")
    def language_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("SQL",):
            raise ValueError("must be one of enum values ('SQL')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateDataSetRecipeNodeRequest:
        """Create an instance of UpdateDataSetRecipeNodeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict["description"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateDataSetRecipeNodeRequest:
        """Create an instance of UpdateDataSetRecipeNodeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateDataSetRecipeNodeRequest.parse_obj(obj)

        _obj = UpdateDataSetRecipeNodeRequest.parse_obj(
            {
                "node_type": obj.get("nodeType"),
                "data_set_id": obj.get("dataSetId"),
                "name": obj.get("name"),
                "description": obj.get("description"),
                "tags": obj.get("tags"),
                "id": obj.get("id"),
                "lock_version": obj.get("lockVersion"),
                "code": obj.get("code"),
                "language": obj.get("language"),
            }
        )
        return _obj
