# coding: utf-8

"""
Earnix import export API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 0.0.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic.v1 import Field, constr

from earnix_elevate.clients.imx.models.connection_response import ConnectionResponse
from earnix_elevate.clients.imx.models.snowflake_auth_response import (
    SnowflakeAuthResponse,
)
from earnix_elevate.clients.imx.models.user_response import UserResponse


class SnowflakeConnectionResponse(ConnectionResponse):
    """
    SnowflakeConnectionResponse
    """

    auth: Optional[SnowflakeAuthResponse] = None
    database: Optional[constr(strict=True, max_length=500)] = None
    var_schema: Optional[constr(strict=True, max_length=500)] = Field(
        default=None, alias="schema"
    )
    warehouse: Optional[constr(strict=True, max_length=500)] = None
    __properties = [
        "id",
        "lockVersion",
        "name",
        "description",
        "tags",
        "createdBy",
        "createdDate",
        "lastModifiedBy",
        "lastModifiedDate",
        "type",
        "database",
        "schema",
        "warehouse",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SnowflakeConnectionResponse:
        """Create an instance of SnowflakeConnectionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of created_by
        if self.created_by:
            _dict["createdBy"] = self.created_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of last_modified_by
        if self.last_modified_by:
            _dict["lastModifiedBy"] = self.last_modified_by.to_dict()
        # set to None if description (nullable) is None
        # and __fields_set__ contains the field
        if self.description is None and "description" in self.__fields_set__:
            _dict["description"] = None

        # set to None if database (nullable) is None
        # and __fields_set__ contains the field
        if self.database is None and "database" in self.__fields_set__:
            _dict["database"] = None

        # set to None if var_schema (nullable) is None
        # and __fields_set__ contains the field
        if self.var_schema is None and "var_schema" in self.__fields_set__:
            _dict["schema"] = None

        # set to None if warehouse (nullable) is None
        # and __fields_set__ contains the field
        if self.warehouse is None and "warehouse" in self.__fields_set__:
            _dict["warehouse"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SnowflakeConnectionResponse:
        """Create an instance of SnowflakeConnectionResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SnowflakeConnectionResponse.parse_obj(obj)

        _obj = SnowflakeConnectionResponse.parse_obj(
            {
                "id": obj.get("id"),
                "lock_version": obj.get("lockVersion"),
                "name": obj.get("name"),
                "description": obj.get("description"),
                "tags": obj.get("tags"),
                "created_by": UserResponse.from_dict(obj.get("createdBy"))
                if obj.get("createdBy") is not None
                else None,
                "created_date": obj.get("createdDate"),
                "last_modified_by": UserResponse.from_dict(obj.get("lastModifiedBy"))
                if obj.get("lastModifiedBy") is not None
                else None,
                "last_modified_date": obj.get("lastModifiedDate"),
                "type": obj.get("type"),
                "database": obj.get("database"),
                "var_schema": obj.get("schema"),
                "warehouse": obj.get("warehouse"),
            }
        )
        return _obj
